/**
 * easyWSDL - easyWSDL toolbox Platform.
 * Copyright (c) 2008,  eBM Websourcing
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the University of California, Berkeley nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE REGENTS AND CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package org.ow2.easywsdl.extensions.multiple;

import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.ow2.easywsdl.extensions.multiple.api.Description;
import org.ow2.easywsdl.extensions.multiple.api.MultipleExtException;
import org.ow2.easywsdl.extensions.multiple.api.MultipleExtReader;
import org.ow2.easywsdl.extensions.multiple.api.MultipleExtWriter;
import org.ow2.easywsdl.extensions.multiple.impl.DescriptionImpl;
import org.ow2.easywsdl.extensions.multiple.impl.MultipleExtReaderImpl;
import org.ow2.easywsdl.extensions.multiple.impl.MultipleExtWriterImpl;
import org.ow2.easywsdl.wsdl.ExtensionFactory;
import org.ow2.easywsdl.wsdl.api.WSDLReader.FeatureConstants;
import org.ow2.easywsdl.wsdl.api.abstractItf.AbsItfDescription;


/**
 * This class is a concrete implementation of the abstract class WSDLFactory.
 * Some ideas used here have been shamelessly copied from the wonderful JAXP and
 * Xerces work.
 * 
 * @author Nicolas Boissel-Dallier - eBM WebSourcing
 */
public class MultipleExtFactoryImpl extends MultipleExtFactory {

    @SuppressWarnings("unchecked")
    public Description addMultipleExtElmt2Description(final List<ExtensionFactory> extFactories, final AbsItfDescription desc) throws MultipleExtException {
    	Description res = null;
    	AbsItfDescription newDesc = desc;
        try {
            Iterator i = extFactories.iterator();
            while(i.hasNext()){
            	newDesc = ((ExtensionFactory)i.next()).addExtElmt2Description(newDesc);
            }
            res = new DescriptionImpl(newDesc);
        } catch (final Exception e) {
            throw new MultipleExtException(e);
        }
       
        return res;
    }

    @Override
    public MultipleExtReader newMultipleExtReader() throws MultipleExtException {
        return new MultipleExtReaderImpl();
    }

    @Override
    public MultipleExtReader newMultipleExtReader(final Map<FeatureConstants, Object> features)
            throws MultipleExtException {
        final MultipleExtReader reader = new MultipleExtReaderImpl();
        ((MultipleExtReaderImpl) reader).setFeatures(features);
        return reader;
    }

    @Override
    public MultipleExtWriter newMultipleExtWriter() throws MultipleExtException {
        return new MultipleExtWriterImpl();
    }

}
